﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using Telerik.Web.UI.Widgets;

public partial class _FileExplorer_ButtonColumn : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		if (!IsPostBack)
		{
			RadFileExplorer1.Configuration.ContentProviderTypeName = typeof(CustomColumnsContentProvider).AssemblyQualifiedName;

			string[] paths = new string[] { "~/Images" };
			RadFileExplorer1.Configuration.ViewPaths = paths;
			RadFileExplorer1.Configuration.UploadPaths = paths;
			RadFileExplorer1.Configuration.DeletePaths = paths;
		}
		AddThumbnailColumn();
	}
	private void AddGridColumn(string name, string uniqueName, bool sortable)
	{
		RemoveGridColumn(uniqueName);
		GridTemplateColumn gridTemplateColumn1 = new GridTemplateColumn();
		gridTemplateColumn1.HeaderText = name;
		if (sortable)
		{
			gridTemplateColumn1.SortExpression = uniqueName;
		}
		gridTemplateColumn1.UniqueName = uniqueName;
		gridTemplateColumn1.DataField = uniqueName;
		RadFileExplorer1.Grid.Columns.Add(gridTemplateColumn1);
	}
	private void RemoveGridColumn(string uniqueName)
	{
		if (!Object.Equals(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName), null))
		{
			RadFileExplorer1.Grid.Columns.Remove(RadFileExplorer1.Grid.Columns.FindByUniqueNameSafe(uniqueName));
		}
	}

	private void AddThumbnailColumn()
	{
		AddGridColumn("Link", "Button", false);
	}
}
public class CustomColumnsContentProvider : Telerik.Web.UI.Widgets.FileSystemContentProvider
{
	public CustomColumnsContentProvider(HttpContext context, string[] searchPatterns, string[] viewPaths, string[] uploadPaths, string[] deletePaths, string selectedUrl, string selectedItemTag)
		: base(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, selectedItemTag)
	{
	}

	public override DirectoryItem ResolveDirectory(string path)
	{
		DirectoryItem oldItem = base.ResolveDirectory(path);
		foreach (FileItem fileItem in oldItem.Files)
		{
			string htmlText = string.Format("<input type='button' value='{0}' onclick='onClickHandler(this);' />", "click me");
			fileItem.Attributes.Add("Button", htmlText);
		}
		return oldItem;
	}
}